<?php
/*
 * This file is part of SELENE.GA4K.
 * (c) 2008 Exbridge,inc. <info@exbridge.jp>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

/**
 * GA4K Function File
 *
 * @copyright   2008- EXBRIDGE,Inc. All Rights Reserved.
 * @link        http://exbridge.jp/
 * @package     SELENE
 * @version     svn:$Id: analytics.php 15028 2009-05-07 08:22:31Z suzuki $
 */

/**
 *  Google Analytics Sender
 *
 *  @param  string      $id         Google Analytics ID
 *  @param  string      $url        WebSite Domain
 *  @param  string      $session    Session
 *  @param  string      $user       User
 */
function sendGoogleAnalytics($id, $url, $session = null, $user = null) {
    if (!isset($id) || !isset($url)) {
        return;
    }

    $send_flg = false;
    //oCtO𔻒
    if(MOBILE_ONLY_FLG) {
        //oC
        $send_flg = isMobile($_SERVER['HTTP_USER_AGENT']);
    }
    else {
        $send_flg = true;
    }

    if ($send_flg) {
        //MtOON̏ꍇ̂݁AGoogle AnalyticsɏʒmiN[Ȃǂ̔rړIj
        $utmac   = $id;
        $utmhn   = $url;
        $utmn    = rand(1000000000, 9999999999);
        $cookie  = (is_null($session)) ? session_id() : $session;
        $uservar = $user;
        $random  = rand(1000000000, 2147483647);
        $today   = time();
        $referer = $_SERVER['HTTP_REFERER'];
        $utmp    = $_SERVER['REQUEST_URI'];

        $urchinUrl = 'http://www.google-analytics.com/__utm.gif?utmwv=1&utmn='.$utmn.'&utmsr=-&utmsc=-&utmul=-&utmje=0&utmfl=-&utmdt=-&utmhn='.$utmhn.'&utmr='.$referer.'&utmp='.$utmp.'&utmac='.$utmac.'&utmcc=__utma%3D'.$cookie.'.'.$random.'.'.$today.'.'.$today.'.'.$today.'.2%3B%2B__utmb%3D'.$cookie.'%3B%2B__utmc%3D'.$cookie.'%3B%2B__utmz%3D'.$cookie.'.'.$today.'.2.2.utmccn%3D(direct)%7Cutmcsr%3D(direct)%7Cutmcmd%3D(none)%3B%2B__utmv%3D'.$cookie.'.'.$uservar.'%3B';

        $header = '';

        if (!empty($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
            $header  = 'Accept-language:' . $_SERVER['HTTP_ACCEPT_LANGUAGE'] . "\r\n";
        }

        if (!empty($_SERVER['HTTP_USER_AGENT'])) {
            $header .= 'User-Agent:' . $_SERVER['HTTP_USER_AGENT'] . "\r\n";
        }

        $opts = array('http' => array( 'method' => 'GET',
                                       'header' => $header));
        $handle = fopen($urchinUrl, 'r', false, stream_context_create($opts));

        $result = fgets($handle);

        fclose($handle);
    }
}


/**
 *  Mobile Judgement
 *
 *  @param  string      $user_agent         User_Agent
 *  @return boolean
 */
function isMobile($user_agent){

    $mobile_flg = false;

    if(eregi(USER_AGENT_PATTERN_DOCOMO, $user_agent)){
        //echo("hR");
        $mobile_flg = true;
    }else if(eregi(USER_AGENT_PATTERN_SOFTBANK, $user_agent)){
        //echo("SoftBank");
        $mobile_flg = true;
    }else if(isset($_SERVER["HTTP_X_JPHONE_MSNAME"])){
        //echo(" J-Phone");
        $mobile_flg = true;
    }else if(eregi(USER_AGENT_PATTERN_AU, $user_agent)){
        //echo("au");
        $mobile_flg = true;
    }else if(eregi(USER_AGENT_PATTERN_WILLCOM, $user_agent)){
        //echo("WILLCOM");
        $mobile_flg = true;
    }else{
        //echo("PC");
        $mobile_flg = false;
    }
    return $mobile_flg;
}

